(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('prop-types'), require('react-router-dom'), require('react'), require('core-js/modules/es6.object.to-string')) :
	typeof define === 'function' && define.amd ? define(['exports', 'prop-types', 'react-router-dom', 'react', 'core-js/modules/es6.object.to-string'], factory) :
	(factory((global['webtrekk-smart-pixel-react'] = {}),global.PropTypes,global.reactRouterDom,global.React));
}(this, (function (exports,PropTypes,reactRouterDom,React) { 'use strict';

PropTypes = PropTypes && PropTypes.hasOwnProperty('default') ? PropTypes['default'] : PropTypes;
var React__default = 'default' in React ? React['default'] : React;

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

var wtSmart;

if (process.env.NODE_ENV === 'development') {
  wtSmart = require('webtrekk-smart-pixel/debug');
} else {
  wtSmart = require('webtrekk-smart-pixel');
}
/**
 * @type {wtSmart|null}
 */


var pixel_ = null;
/**
 * @returns {Window}
 */

var getWindow_ = function getWindow_() {
  return window;
};
/**
 * @returns {HTMLDocument}
 */


var getDocument_ = function getDocument_() {
  return window.document;
};

var emptyObject = {};
/**
 *
 */

var init_ = function init_() {
  var window_ = getWindow_();
  pixel_ = wtSmart.use(window_, getDocument_());
  window_['wtSmart'] = pixel_;
};
/**
 * @constructor
 */


var WebtrekkSmartPixelReact =
/*#__PURE__*/
function () {
  function WebtrekkSmartPixelReact() {
    _classCallCheck(this, WebtrekkSmartPixelReact);
  }

  _createClass(WebtrekkSmartPixelReact, [{
    key: "call",

    /**
     * @param {function(wtSmart: wtSmart)} call
     */
    value: function call(_call) {
      if (pixel_ === null) {
        init_();
      }

      pixel_.push(_call);
    }
  }, {
    key: "init",

    /**
     * @param {object} data
     */
    value: function init() {
      var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : emptyObject;
      this.call(function (pix) {
        pix.init.add(data);
      });
    }
  }, {
    key: "advanced",

    /**
     * @param {object} data
     */
    value: function advanced() {
      var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : emptyObject;
      this.call(function (pix) {
        pix.advanced.add(data);
      });
    }
  }, {
    key: "page",

    /**
     * @param {string} name
     * @param {object} data
     */
    value: function page() {
      var name = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
      var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : emptyObject;
      this.call(function (pix) {
        pix.page.data.add(name, data);
      });
    }
  }, {
    key: "action",

    /**
     * @param {object} data
     */
    value: function action() {
      var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : emptyObject;
      this.call(function (pix) {
        pix.action.data.add(data);
      });
    }
  }, {
    key: "session",

    /**
     * @param {object} data
     */
    value: function session() {
      var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : emptyObject;
      this.call(function (pix) {
        pix.session.data.add(data);
      });
    }
  }, {
    key: "campaign",

    /**
     * @param {object} data
     */
    value: function campaign() {
      var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : emptyObject;
      this.call(function (pix) {
        pix.campaign.data.add(data);
      });
    }
  }, {
    key: "customer",

    /**
     * @param {string} id
     * @param {object} data
     * @param {boolean} validation
     */
    value: function customer() {
      var id = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
      var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : emptyObject;
      var validation = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      this.call(function (pix) {
        pix.customer.data.add(id, data, validation);
      });
    }
  }, {
    key: "product",

    /**
     * @param {string} action
     * @param {object} data
     */
    value: function product() {
      var action = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'view';
      var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : emptyObject;
      this.call(function (pix) {
        var method = action === 'view' || action === 'basket' ? 'set' : 'add';
        pix.product[action].data[method]([data]);
      });
    }
  }, {
    key: "products",

    /**
     * @param {string} action
     * @param {Array} data
     */
    value: function products() {
      var action = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'view';
      var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
      this.call(function (pix) {
        var method = action === 'view' || action === 'basket' ? 'set' : 'add';
        pix.product[action].data[method](data);
      });
    }
  }, {
    key: "order",

    /**
     * @param {object} data
     */
    value: function order() {
      var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : emptyObject;
      this.call(function (pix) {
        pix.order.data.add(data);
      });
    }
  }, {
    key: "extension",

    /**
     * @param {string} extension
     * @param {string} action
     * @param {object} config
     */
    value: function extension() {
      var _extension = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

      var action = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'activate';
      var config = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : emptyObject;

      if (!_extension) {
        return 0;
      }

      this.call(function (pix) {
        pix.extension[_extension][action](config);
      });
    }
  }, {
    key: "track",

    /**
     * @param {boolean} keepData
     */
    value: function track() {
      var keepData = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      this.call(function (pix) {
        pix.track(keepData);
      });
    }
  }, {
    key: "trackPage",

    /**
     *
     */
    value: function trackPage() {
      var keepData = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      this.call(function (pix) {
        pix.trackPage(keepData);
      });
    }
  }, {
    key: "trackAction",

    /**
     *
     */
    value: function trackAction() {
      var keepData = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      this.call(function (pix) {
        pix.trackAction(keepData);
      });
    }
  }]);

  return WebtrekkSmartPixelReact;
}();

var SmartPixelReact = new WebtrekkSmartPixelReact();

var WebtrekkReactComponent =
/*#__PURE__*/
function (_React$Component) {
  _inherits(WebtrekkReactComponent, _React$Component);

  /**
   * @param {string} type
   */
  function WebtrekkReactComponent(type) {
    var _this;

    _classCallCheck(this, WebtrekkReactComponent);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(WebtrekkReactComponent).call(this));
    _this.type = type;
    return _this;
  }
  /**
   * @param {string} type
   * @param {object} props
   */


  _createClass(WebtrekkReactComponent, [{
    key: "addConfigurationData",
    value: function addConfigurationData() {
      var type = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.type;
      var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.props;
      SmartPixelReact[type](props);
    }
    /**
     * @param {string} type
     * @param {object} props
     */

  }, {
    key: "addTrackingData",
    value: function addTrackingData() {
      var type = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.type;
      var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.props;
      SmartPixelReact[type](props);
    }
    /**
     * @param {object} props
     */

  }, {
    key: "addPageTrackingData",
    value: function addPageTrackingData() {
      var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.props;
      SmartPixelReact.page(props.name, props);
    }
    /**
     * @param {object} props
     */

  }, {
    key: "addCustomerTrackingData",
    value: function addCustomerTrackingData() {
      var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.props;
      SmartPixelReact.customer(props.id, props, props.validation);
    }
    /**
     * @param {object} props
     */

  }, {
    key: "addProductTrackingData",
    value: function addProductTrackingData() {
      var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.props;
      SmartPixelReact.product(props.action, props);
    }
    /**
     * @param {string} extension
     * @param {string} action
     * @param {object} config
     */

  }, {
    key: "addExtension",
    value: function addExtension(extension) {
      var action = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'activate';
      var config = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      SmartPixelReact.extension(extension, action, config);
    }
    /**
     * @param {object} ref
     * @param {object} props
     */

  }, {
    key: "addContentEngagementElement",
    value: function addContentEngagementElement() {
      var ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.elementRef;
      var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.props;
      SmartPixelReact.call(function (pix) {
        pix.extension.content_engagement.activate();
        pix.extension.content_engagement.add({
          selector: props.selector ? props.selector : ref.current,
          name: props.name,
          config: props
        });
      });
    }
    /**
     * @param {object} ref
     * @param {object} props
     */

  }, {
    key: "addProductListElement",
    value: function addProductListElement() {
      var ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.elementRef;
      var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.props;
      SmartPixelReact.call(function (pix) {
        pix.extension.product_list_tracking.activate();
        pix.extension.product_list_tracking.add({
          selector: props.selector ? props.selector : ref.current,
          data: props
        });
      });
    }
    /**
     * @param {object} ref
     * @param {object} props
     */

  }, {
    key: "addTeaserElement",
    value: function addTeaserElement() {
      var ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.elementRef;
      var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.props;
      SmartPixelReact.call(function (pix) {
        pix.extension.teaser_tracking.activate();
        pix.extension.teaser_tracking.add({
          selector: props.selector ? props.selector : ref.current,
          data: props,
          conversion: props
        });
      });
    }
    /**
     *
     */

  }, {
    key: "trackPageView",
    value: function trackPageView() {
      SmartPixelReact.trackPage();
    }
    /**
     *
     */

    /*
    trackAction() {
        webtrekkSmartPixelReact.trackAction();
    }
    */

    /**
     * @override
     */

  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.type === 'init' || this.type === 'advanced') {
        this.addConfigurationData();
      } else if (this.type === 'page') {
        this.addPageTrackingData();
      } else if (this.type === 'customer') {
        this.addCustomerTrackingData();
      } else if (this.type === 'product') {
        this.addProductTrackingData();
      } else {
        this.addTrackingData();
      }
    }
    /**
     * @override
     */

  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.componentDidMount();
    }
    /**
     * @override
     *
     * @returns {null}
     */

  }, {
    key: "render",
    value: function render() {
      return null;
    }
  }]);

  return WebtrekkReactComponent;
}(React__default.Component);

var WebtrekkAutoTracking =
/*#__PURE__*/
function (_WebtrekkReactCompone) {
  _inherits(WebtrekkAutoTracking, _WebtrekkReactCompone);

  function WebtrekkAutoTracking() {
    _classCallCheck(this, WebtrekkAutoTracking);

    return _possibleConstructorReturn(this, _getPrototypeOf(WebtrekkAutoTracking).call(this, 'auto'));
  }

  _createClass(WebtrekkAutoTracking, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.addConfigurationData('init');

      if (this.props.activateActions) {
        this.addExtension('action');
      }

      if (this.props.activateTeaser) {
        this.addExtension('teaser_tracking');
      }

      if (this.props.activateProductList) {
        this.addExtension('product_list_tracking');
      }

      if (this.props.activateContentEngagement) {
        this.addExtension('content_engagement');
      }

      this.trackPageView();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(_ref) {
      var _this = this;

      var history = _ref.history;

      if (history.action === 'PUSH' || history.action === 'POP') {
        window.setTimeout(function () {
          _this.trackPageView();

          if (_this.props.activateActions) {
            _this.addExtension('action', 'reload');
          }
        }, 500);
      }
    }
  }]);

  return WebtrekkAutoTracking;
}(WebtrekkReactComponent);

WebtrekkAutoTracking.propTypes = {
  trackId: PropTypes.string.isRequired,
  trackDomain: PropTypes.string.isRequired,
  activateActions: PropTypes.bool,
  activateTeaser: PropTypes.bool,
  activateProductList: PropTypes.bool,
  activateContentEngagement: PropTypes.bool
};
WebtrekkAutoTracking.defaultProps = {
  trackId: null,
  trackDomain: null,
  activateActions: false,
  activateTeaser: false,
  activateProductList: false,
  activateContentEngagement: false
};
var AutoTracking = reactRouterDom.withRouter(WebtrekkAutoTracking);

var WebtrekkInitData =
/*#__PURE__*/
function (_WebtrekkReactCompone) {
  _inherits(WebtrekkInitData, _WebtrekkReactCompone);

  function WebtrekkInitData() {
    _classCallCheck(this, WebtrekkInitData);

    return _possibleConstructorReturn(this, _getPrototypeOf(WebtrekkInitData).call(this, 'init'));
  }

  return WebtrekkInitData;
}(WebtrekkReactComponent);

WebtrekkInitData.propTypes = {
  trackId: PropTypes.string.isRequired,
  trackDomain: PropTypes.string.isRequired,
  domain: PropTypes.arrayOf(PropTypes.string),
  cookie: PropTypes.oneOf(['1', '3'])
};
WebtrekkInitData.defaultProps = {
  trackId: null,
  trackDomain: null,
  domain: null,
  cookie: null
};

var WebtrekkAdvancedData =
/*#__PURE__*/
function (_WebtrekkReactCompone) {
  _inherits(WebtrekkAdvancedData, _WebtrekkReactCompone);

  function WebtrekkAdvancedData() {
    _classCallCheck(this, WebtrekkAdvancedData);

    return _possibleConstructorReturn(this, _getPrototypeOf(WebtrekkAdvancedData).call(this, 'advanced'));
  }

  return WebtrekkAdvancedData;
}(WebtrekkReactComponent);

WebtrekkAdvancedData.propTypes = {
  secureCookie: PropTypes.bool,
  optOutName: PropTypes.string,
  requestObfuscation: PropTypes.bool,
  execCDB: PropTypes.bool,
  useCDBCache: PropTypes.bool,
  useHashForDefaultPageName: PropTypes.bool,
  useParamsForDefaultPageName: PropTypes.arrayOf(PropTypes.string),
  requestQueue: PropTypes.shape({
    activated: PropTypes.bool,
    ttl: PropTypes.number,
    resendInterval: PropTypes.number,
    size: PropTypes.number
  })
};
WebtrekkAdvancedData.defaultProps = {
  secureCookie: null,
  optOutName: null,
  requestObfuscation: null,
  execCDB: null,
  useCDBCache: null,
  useHashForDefaultPageName: null,
  useParamsForDefaultPageName: null,
  requestQueue: {
    activated: null,
    ttl: null,
    resendInterval: null,
    size: null
  }
};

var WebtrekkCampaignData =
/*#__PURE__*/
function (_WebtrekkReactCompone) {
  _inherits(WebtrekkCampaignData, _WebtrekkReactCompone);

  function WebtrekkCampaignData() {
    _classCallCheck(this, WebtrekkCampaignData);

    return _possibleConstructorReturn(this, _getPrototypeOf(WebtrekkCampaignData).call(this, 'campaign'));
  }

  return WebtrekkCampaignData;
}(WebtrekkReactComponent);

WebtrekkCampaignData.propTypes = {
  id: PropTypes.string.isRequired,
  mediaCode: PropTypes.arrayOf(PropTypes.string),
  oncePerSession: PropTypes.bool,
  parameter: PropTypes.objectOf(PropTypes.string)
};
WebtrekkCampaignData.defaultProps = {
  id: null,
  mediaCode: null,
  oncePerSession: null,
  parameter: null
};

var WebtrekkCustomerData =
/*#__PURE__*/
function (_WebtrekkReactCompone) {
  _inherits(WebtrekkCustomerData, _WebtrekkReactCompone);

  function WebtrekkCustomerData() {
    _classCallCheck(this, WebtrekkCustomerData);

    return _possibleConstructorReturn(this, _getPrototypeOf(WebtrekkCustomerData).call(this, 'customer'));
  }

  return WebtrekkCustomerData;
}(WebtrekkReactComponent);

WebtrekkCustomerData.propTypes = {
  id: PropTypes.string.isRequired,
  email: PropTypes.string,
  emailRID: PropTypes.string,
  emailOptin: PropTypes.bool,
  firstName: PropTypes.string,
  lastName: PropTypes.string,
  telephone: PropTypes.string,
  gender: PropTypes.number,
  birthday: PropTypes.string,
  country: PropTypes.string,
  city: PropTypes.string,
  postalCode: PropTypes.string,
  street: PropTypes.string,
  streetNumber: PropTypes.string,
  validation: PropTypes.bool,
  category: PropTypes.objectOf(PropTypes.string)
};
WebtrekkCustomerData.defaultProps = {
  id: null,
  email: null,
  emailRID: null,
  emailOptin: null,
  firstName: null,
  lastName: null,
  telephone: null,
  gender: null,
  birthday: null,
  country: null,
  city: null,
  postalCode: null,
  street: null,
  streetNumber: null,
  validation: null,
  category: null
};

var WebtrekkOrderData =
/*#__PURE__*/
function (_WebtrekkReactCompone) {
  _inherits(WebtrekkOrderData, _WebtrekkReactCompone);

  function WebtrekkOrderData() {
    _classCallCheck(this, WebtrekkOrderData);

    return _possibleConstructorReturn(this, _getPrototypeOf(WebtrekkOrderData).call(this, 'order'));
  }

  return WebtrekkOrderData;
}(WebtrekkReactComponent);

WebtrekkOrderData.propTypes = {
  value: PropTypes.number.isRequired,
  id: PropTypes.string,
  currency: PropTypes.string,
  couponValue: PropTypes.number,
  paymentMethod: PropTypes.string,
  shippingService: PropTypes.string,
  shippingSpeed: PropTypes.string,
  shippingCosts: PropTypes.number,
  grossMargin: PropTypes.number,
  orderStatus: PropTypes.string,
  parameter: PropTypes.objectOf(PropTypes.string)
};
WebtrekkOrderData.defaultProps = {
  value: null,
  id: null,
  currency: null,
  couponValue: null,
  paymentMethod: null,
  shippingService: null,
  shippingSpeed: null,
  shippingCosts: null,
  grossMargin: null,
  orderStatus: null,
  parameter: null
};

var WebtrekkPageData =
/*#__PURE__*/
function (_WebtrekkReactCompone) {
  _inherits(WebtrekkPageData, _WebtrekkReactCompone);

  function WebtrekkPageData() {
    _classCallCheck(this, WebtrekkPageData);

    return _possibleConstructorReturn(this, _getPrototypeOf(WebtrekkPageData).call(this, 'page'));
  }

  return WebtrekkPageData;
}(WebtrekkReactComponent);

WebtrekkPageData.propTypes = {
  name: PropTypes.string,
  search: PropTypes.string,
  numberSearchResults: PropTypes.number,
  errorMessages: PropTypes.string,
  paywall: PropTypes.bool,
  articleTitle: PropTypes.string,
  contentTags: PropTypes.string,
  title: PropTypes.string,
  type: PropTypes.string,
  length: PropTypes.string,
  daysSincePublication: PropTypes.number,
  testVariant: PropTypes.string,
  testExperiment: PropTypes.string,
  parameter: PropTypes.objectOf(PropTypes.string),
  category: PropTypes.objectOf(PropTypes.string),
  goal: PropTypes.objectOf(PropTypes.string)
};
WebtrekkPageData.defaultProps = {
  name: null,
  search: null,
  numberSearchResults: null,
  errorMessages: null,
  paywall: null,
  articleTitle: null,
  contentTags: null,
  title: null,
  type: null,
  length: null,
  daysSincePublication: null,
  testVariant: null,
  testExperiment: null,
  parameter: null,
  category: null,
  goal: null
};

var WebtrekkProductData =
/*#__PURE__*/
function (_WebtrekkReactCompone) {
  _inherits(WebtrekkProductData, _WebtrekkReactCompone);

  function WebtrekkProductData() {
    _classCallCheck(this, WebtrekkProductData);

    return _possibleConstructorReturn(this, _getPrototypeOf(WebtrekkProductData).call(this, 'product'));
  }

  return WebtrekkProductData;
}(WebtrekkReactComponent);

WebtrekkProductData.propTypes = {
  id: PropTypes.string.isRequired,
  action: PropTypes.oneOf(['list', 'view', 'basket', 'confirmation']).isRequired,
  cost: PropTypes.number,
  quantity: PropTypes.number,
  variant: PropTypes.string,
  soldOut: PropTypes.bool,
  parameter: PropTypes.objectOf(PropTypes.string),
  category: PropTypes.objectOf(PropTypes.string)
};
WebtrekkProductData.defaultProps = {
  id: null,
  action: null,
  cost: null,
  quantity: null,
  variant: null,
  soldOut: null,
  parameter: null,
  category: null
};

var WebtrekkSessionData =
/*#__PURE__*/
function (_WebtrekkReactCompone) {
  _inherits(WebtrekkSessionData, _WebtrekkReactCompone);

  function WebtrekkSessionData() {
    _classCallCheck(this, WebtrekkSessionData);

    return _possibleConstructorReturn(this, _getPrototypeOf(WebtrekkSessionData).call(this, 'session'));
  }

  return WebtrekkSessionData;
}(WebtrekkReactComponent);

WebtrekkSessionData.propTypes = {
  loginStatus: PropTypes.string,
  parameter: PropTypes.objectOf(PropTypes.string)
};
WebtrekkSessionData.defaultProps = {
  loginStatus: null,
  parameter: null
};

var createRef = React__default.createRef || function () {
  function getRef(refObject) {
    if (!refObject) {
      return null;
    }

    var ref = refObject;

    if (Object.keys(ref).length === 1) {
      if (ref.hasOwnProperty('current')) {
        ref = ref.current;
      } else if (ref.hasOwnProperty('value')) {
        ref = ref.value;
      }
    }

    return ref;
  }

  function ref(instanceOrNode) {
    ref.current = getRef(instanceOrNode) || null;
  }

  ref.current = null;
  return ref;
};

var WebtrekkTeaser =
/*#__PURE__*/
function (_WebtrekkReactCompone) {
  _inherits(WebtrekkTeaser, _WebtrekkReactCompone);

  function WebtrekkTeaser() {
    var _this;

    _classCallCheck(this, WebtrekkTeaser);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(WebtrekkTeaser).call(this, 'teaser_tracking'));
    _this.elementRef = createRef();
    return _this;
  }

  _createClass(WebtrekkTeaser, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.addTeaserElement();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.componentDidMount();
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var children = React__default.Children.map(this.props.children, function (element) {
        return React__default.cloneElement(element, {
          ref: _this2.elementRef
        });
      });
      return children[0];
    }
  }]);

  return WebtrekkTeaser;
}(WebtrekkReactComponent);

WebtrekkTeaser.propTypes = {
  selector: PropTypes.string,
  name: PropTypes.string.isRequired,
  rank: PropTypes.string,
  content: PropTypes.string,
  variant: PropTypes.string,
  seen: PropTypes.bool,
  type: PropTypes.oneOf(['view', 'click', 'product']),
  goal: PropTypes.oneOf(['order', 'goal', 'both']),
  value: PropTypes.string
};
WebtrekkTeaser.defaultProps = {
  selector: null,
  name: null,
  rank: null,
  content: null,
  variant: null,
  seen: null,
  type: null,
  goal: null,
  value: null
};

var WebtrekkProductList =
/*#__PURE__*/
function (_WebtrekkReactCompone) {
  _inherits(WebtrekkProductList, _WebtrekkReactCompone);

  function WebtrekkProductList() {
    var _this;

    _classCallCheck(this, WebtrekkProductList);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(WebtrekkProductList).call(this, 'product_list_tracking'));
    _this.elementRef = createRef();
    return _this;
  }

  _createClass(WebtrekkProductList, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.addProductListElement();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.componentDidMount();
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var children = React__default.Children.map(this.props.children, function (element) {
        return React__default.cloneElement(element, {
          ref: _this2.elementRef
        });
      });
      return children[0];
    }
  }]);

  return WebtrekkProductList;
}(WebtrekkReactComponent);

WebtrekkProductList.propTypes = {
  selector: PropTypes.string,
  id: PropTypes.string.isRequired,
  position: PropTypes.number.isRequired,
  cost: PropTypes.number,
  quantity: PropTypes.number,
  variant: PropTypes.string,
  soldOut: PropTypes.bool,
  category: PropTypes.objectOf(PropTypes.string),
  parameter: PropTypes.objectOf(PropTypes.string)
};
WebtrekkProductList.defaultProps = {
  selector: null,
  id: null,
  position: null,
  cost: null,
  quantity: null,
  variant: null,
  soldOut: null,
  category: null,
  parameter: null
};

var WebtrekkContentEngagement =
/*#__PURE__*/
function (_WebtrekkReactCompone) {
  _inherits(WebtrekkContentEngagement, _WebtrekkReactCompone);

  function WebtrekkContentEngagement() {
    var _this;

    _classCallCheck(this, WebtrekkContentEngagement);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(WebtrekkContentEngagement).call(this, 'content_engagement'));
    _this.elementRef = createRef();
    return _this;
  }

  _createClass(WebtrekkContentEngagement, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.addContentEngagementElement();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.componentDidMount();
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var children = React__default.Children.map(this.props.children, function (element) {
        return React__default.cloneElement(element, {
          ref: _this2.elementRef
        });
      });
      return children[0];
    }
  }]);

  return WebtrekkContentEngagement;
}(WebtrekkReactComponent);

WebtrekkContentEngagement.propTypes = {
  selector: PropTypes.string,
  name: PropTypes.string,
  percentageStepsInAnalytics: PropTypes.number,
  sendContentEngagement: PropTypes.oneOf([0, 1, 2]),
  percentageReached: PropTypes.number,
  secondsReached: PropTypes.number,
  largeBrowserResolution: PropTypes.number,
  largeBrowserSeconds: PropTypes.number,
  mediumBrowserResolution: PropTypes.number,
  mediumBrowserSeconds: PropTypes.number,
  smallBrowserResolution: PropTypes.number,
  smallBrowserSeconds: PropTypes.number
};
WebtrekkContentEngagement.defaultProps = {
  selector: null,
  name: null,
  percentageStepsInAnalytics: null,
  sendContentEngagement: null,
  percentageReached: null,
  secondsReached: null,
  largeBrowserResolution: null,
  largeBrowserSeconds: null,
  mediumBrowserResolution: null,
  mediumBrowserSeconds: null,
  smallBrowserResolution: null,
  smallBrowserSeconds: null
};

var WebtrekkExtension =
/*#__PURE__*/
function (_WebtrekkReactCompone) {
  _inherits(WebtrekkExtension, _WebtrekkReactCompone);

  function WebtrekkExtension() {
    _classCallCheck(this, WebtrekkExtension);

    return _possibleConstructorReturn(this, _getPrototypeOf(WebtrekkExtension).call(this, 'extension'));
  }

  _createClass(WebtrekkExtension, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.addExtension(this.props.name, this.props.action, this.props.config);
    }
  }]);

  return WebtrekkExtension;
}(WebtrekkReactComponent);

WebtrekkExtension.propTypes = {
  name: PropTypes.string.isRequired,
  action: PropTypes.string.isRequired,
  config: PropTypes.object
};
WebtrekkExtension.defaultProps = {
  name: null,
  action: null,
  config: null
};

var webtrekkMiddleware = function webtrekkMiddleware() {
  var actions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return function (_ref) {
    var dispatch = _ref.dispatch,
        getState = _ref.getState;
    return function (next) {
      return function (action) {
        var nextValue = next(action);

        if (typeof actions[action.type] === 'function') {
          actions[action.type](getState(), action);
          return nextValue;
        }

        if (!action.webtrekk) {
          return nextValue;
        }

        var isWebtrekkAction = true;
        var webtrekk = action.webtrekk;
        var type = webtrekk.type || '';
        var data = webtrekk.data || {};
        var sendInstantly = webtrekk.sendInstantly || false;

        switch (type) {
          case 'webtrekk/init':
            SmartPixelReact.init(data);
            break;

          case 'webtrekk/advanced':
            SmartPixelReact.advanced(data);
            break;

          case 'webtrekk/page':
            SmartPixelReact.page(data.name, data);
            break;

          case 'webtrekk/action':
            SmartPixelReact.action(data);
            break;

          case 'webtrekk/session':
            SmartPixelReact.session(data);
            break;

          case 'webtrekk/campaign':
            SmartPixelReact.campaign(data);
            break;

          case 'webtrekk/customer':
            SmartPixelReact.customer(data.id, data, data.validation);
            break;

          case 'webtrekk/product':
            SmartPixelReact.product(webtrekk.action, data);
            break;

          case 'webtrekk/products':
            SmartPixelReact.products(webtrekk.action, data);
            break;

          case 'webtrekk/order':
            SmartPixelReact.order(data);
            break;

          case 'webtrekk/extension':
            SmartPixelReact.extension(data.extension, data.action, data);
            break;

          case 'webtrekk/track':
            SmartPixelReact.track(data);
            break;

          case 'webtrekk/trackPage':
            SmartPixelReact.trackPage(data);
            break;

          case 'webtrekk/trackAction':
            SmartPixelReact.trackAction(data);
            break;

          default:
            isWebtrekkAction = false;
            break;
        }

        if (isWebtrekkAction && sendInstantly) {
          SmartPixelReact.track();
        }

        return nextValue;
      };
    };
  };
};

var webtrekkReducer = function webtrekkReducer() {
  var actions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return function () {
    var customReducer = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : function () {};
    return React.useCallback(function (state, action) {
      var customReducerValue = customReducer(state, action);

      if (typeof actions[action.type] === 'function') {
        actions[action.type](state, action, customReducerValue);
        return customReducerValue;
      }

      if (!action.webtrekk) {
        return customReducerValue;
      }

      var isWebtrekkAction = true;
      var webtrekk = action.webtrekk;
      var type = webtrekk.type || '';
      var data = webtrekk.data || {};
      var sendInstantly = webtrekk.sendInstantly || false;

      switch (type) {
        case 'webtrekk/init':
          SmartPixelReact.init(data);
          break;

        case 'webtrekk/advanced':
          SmartPixelReact.advanced(data);
          break;

        case 'webtrekk/page':
          SmartPixelReact.page(data.name, data);
          break;

        case 'webtrekk/action':
          SmartPixelReact.action(data);
          break;

        case 'webtrekk/session':
          SmartPixelReact.session(data);
          break;

        case 'webtrekk/campaign':
          SmartPixelReact.campaign(data);
          break;

        case 'webtrekk/customer':
          SmartPixelReact.customer(data.id, data, data.validation);
          break;

        case 'webtrekk/product':
          SmartPixelReact.product(webtrekk.action, data);
          break;

        case 'webtrekk/products':
          SmartPixelReact.products(webtrekk.action, data);
          break;

        case 'webtrekk/order':
          SmartPixelReact.order(data);
          break;

        case 'webtrekk/extension':
          SmartPixelReact.extension(data.extension, data.action, data);
          break;

        case 'webtrekk/track':
          SmartPixelReact.track(data);
          break;

        case 'webtrekk/trackPage':
          SmartPixelReact.trackPage(data);
          break;

        case 'webtrekk/trackAction':
          SmartPixelReact.trackAction(data);
          break;

        default:
          isWebtrekkAction = false;
          break;
      }

      if (isWebtrekkAction && sendInstantly) {
        SmartPixelReact.track();
      }

      return customReducerValue;
    }, [customReducer, actions]);
  };
};

var WebtrekkAutoTracking$1 = AutoTracking;
var WebtrekkInitData$1 = WebtrekkInitData;
var WebtrekkAdvancedData$1 = WebtrekkAdvancedData;
var WebtrekkCampaignData$1 = WebtrekkCampaignData;
var WebtrekkCustomerData$1 = WebtrekkCustomerData;
var WebtrekkOrderData$1 = WebtrekkOrderData;
var WebtrekkPageData$1 = WebtrekkPageData;
var WebtrekkProductData$1 = WebtrekkProductData;
var WebtrekkSessionData$1 = WebtrekkSessionData;
var WebtrekkTeaser$1 = WebtrekkTeaser;
var WebtrekkProductList$1 = WebtrekkProductList;
var WebtrekkContentEngagement$1 = WebtrekkContentEngagement;
var WebtrekkExtension$1 = WebtrekkExtension;
var WebtrekkSmartPixelReact$1 = SmartPixelReact;
var webtrekkMiddleware$1 = webtrekkMiddleware;
var webtrekkReducer$1 = webtrekkReducer; // compatibility for v0

var webtrekkSmartPixelReact = SmartPixelReact;
var index = {
  WebtrekkAutoTracking: WebtrekkAutoTracking$1,
  WebtrekkInitData: WebtrekkInitData$1,
  WebtrekkAdvancedData: WebtrekkAdvancedData$1,
  WebtrekkCampaignData: WebtrekkCampaignData$1,
  WebtrekkCustomerData: WebtrekkCustomerData$1,
  WebtrekkOrderData: WebtrekkOrderData$1,
  WebtrekkPageData: WebtrekkPageData$1,
  WebtrekkProductData: WebtrekkProductData$1,
  WebtrekkSessionData: WebtrekkSessionData$1,
  WebtrekkTeaser: WebtrekkTeaser$1,
  WebtrekkProductList: WebtrekkProductList$1,
  WebtrekkContentEngagement: WebtrekkContentEngagement$1,
  WebtrekkExtension: WebtrekkExtension$1,
  WebtrekkSmartPixelReact: WebtrekkSmartPixelReact$1,
  webtrekkMiddleware: webtrekkMiddleware$1,
  webtrekkReducer: webtrekkReducer$1,
  // compatibility for v0
  webtrekkSmartPixelReact
};

exports.WebtrekkAutoTracking = WebtrekkAutoTracking$1;
exports.WebtrekkInitData = WebtrekkInitData$1;
exports.WebtrekkAdvancedData = WebtrekkAdvancedData$1;
exports.WebtrekkCampaignData = WebtrekkCampaignData$1;
exports.WebtrekkCustomerData = WebtrekkCustomerData$1;
exports.WebtrekkOrderData = WebtrekkOrderData$1;
exports.WebtrekkPageData = WebtrekkPageData$1;
exports.WebtrekkProductData = WebtrekkProductData$1;
exports.WebtrekkSessionData = WebtrekkSessionData$1;
exports.WebtrekkTeaser = WebtrekkTeaser$1;
exports.WebtrekkProductList = WebtrekkProductList$1;
exports.WebtrekkContentEngagement = WebtrekkContentEngagement$1;
exports.WebtrekkExtension = WebtrekkExtension$1;
exports.WebtrekkSmartPixelReact = WebtrekkSmartPixelReact$1;
exports.webtrekkMiddleware = webtrekkMiddleware$1;
exports.webtrekkReducer = webtrekkReducer$1;
exports.webtrekkSmartPixelReact = webtrekkSmartPixelReact;
exports['default'] = index;

Object.defineProperty(exports, '__esModule', { value: true });

})));
